-- https://gist.github.com/luizcarlos1405/4e00f8a91ae3d31481cfaba66adf3fc5

HC = require 'lib.hc'					-- https://hc.readthedocs.io/en/latest/index.html
Camera = require 'lib.hump.camera'		-- https://hump.readthedocs.io/en/latest/camera.html
require("lib.functions")


require("class.player")

tt = love.graphics.newImage("src/tt.png")


screenWidth  = love.graphics.getWidth()
screenHeight = love.graphics.getHeight()

debugMode = true
--love.mouse.setGrab( true )





-- =================================================================================
function love.load()
	Player:load()
	
	cameraScale = 1
	cameraAngle = 0
	camera = Camera(Player.x, Player.y)
end

function love.draw()
    camera:attach()
		love.graphics.draw(tt, 0, 0)
		love.graphics.rectangle("fill", 90,40, 820, 30)
		love.graphics.line(200,150, 400,150, 500,300, 100,300, 200,150)
		
		Player:draw()
    camera:detach()
	
	-- тут рисуем то, что всегда должно быть видно на экране.
	--love.graphics.setColor(255,56,56)
	--love.graphics.rectangle("line", 10,10, 40, 10)
	love.graphics.print("Player.x,Player.y:"..Player.x..","..Player.y, 10,50)
	love.graphics.print("Player.destX,Player.destY:"..Player.destX..","..Player.destY, 10,70)
	mouse_x, mouse_y = camera:worldCoords(love.mouse.getX(), love.mouse.getY())
	love.graphics.print("mouse.x,mouse.y:"..mouse_x..","..mouse_y, 10,90)
	love.graphics.print("Player.angle:"..Player.angle, 10,110)
	
	if (debugMode==true) then
		love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	end
	
	-- рисуем динию точками
	if (Player.isMoveShowLine == 1) then
		-- Линия до курсора мыши
		--player_x, player_y = camera:toCameraCoords(Player.x, Player.y)
		--drawLine(player_x, player_y, love.mouse.getX(), love.mouse.getY())
		
		player_x, player_y = camera:cameraCoords(Player.x, Player.y)
		player_x2, player_y2 = camera:cameraCoords(Player.destX, Player.destY)
		drawLine(player_x, player_y, player_x2, player_y2)
	else
		player_x, player_y = camera:cameraCoords(Player.x, Player.y)
		drawLine(player_x, player_y, love.mouse.getX(), love.mouse.getY())
	end
end

function love.update(dt)
	Player:update(dt)
	
	--inputCamera(dt)
	--camera:move(math.floor(Player.x), math.floor(Player.y))
	--camera:lockPosition(Player.x, Player.y, Camera.smooth.damped(2))
	--camera:update(dt)
	
	--camera:lockPosition(math.round(Player.x), math.round(Player.y), Camera.smooth.damped(2))

    local dx,dy = Player.x - camera.x, Player.y - camera.y
    camera:move(math.round(dx), math.round(dy))
end

function love.mousepressed(x, y, button, istouch, presses )
	if button == 2 then
		if (Player.isMove==0) then
			x1,y1 = camera:worldCoords(love.mouse.getX(), love.mouse.getY())
			Player.destX, Player.destY = x1,y1
			Player.isMove = 1
			Player.isMoveShowLine = 1
		end
	end
end

function inputCamera(dt)
	if love.keyboard.isDown("kp-") then
		cameraScale = cameraScale - 0.01
	end
	if love.keyboard.isDown("kp+") then
		cameraScale = cameraScale + 0.01
	end
	--camera.scale = cameraScale -- увеличить камеру
		
		
	if love.keyboard.isDown("[") then
		cameraAngle = cameraAngle - 0.01
	end
	if love.keyboard.isDown("]") then
		cameraAngle = cameraAngle + 0.01
	end
	--camera.rotation = cameraAngle -- поворот камеры на угол в радианах	
end





-- =================================================================================
function love.keypressed(key, scancode, isrepeat)
	-- включить или выключить режим отладки
	if (key=='f1') then
		if (debugMode==false) then
			debugMode = true
		else
			debugMode = false
		end
	end
end